/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_AbdominalArteriesLateral;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_AbdominalArteriesLateral;
import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumChestCardiacSNOMEDMap;

/**
 * This class represents AbdominalArteriesLateral CID12111
 */
public class AbdominalArteriesLateral_CID12111 {

	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	/**
	 * Instantiates a new AbdominalArteriesLateral_CID12111 Template 
	 */
	public AbdominalArteriesLateral_CID12111()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}
	
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumAbdominalArteriesLateral Object of EnumCM_AbdominalArteriesLateral represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_AbdominalArteriesLateral enumAbdominalArteriesLateral)
	{
		switch(enumAbdominalArteriesLateral)
		{
		case ACCESSORY_RENAL_ARTERY: this.strCodeValue =EnumCV_AbdominalArteriesLateral.ACCESSORY_RENAL_ARTERY_T_46640.getValue(); break;
		case GASTRIC_ARTERY: this.strCodeValue =EnumCV_AbdominalArteriesLateral.GASTRIC_ARTERY_T_46410.getValue(); break;
		case OVARIAN_ARTERY: this.strCodeValue =EnumCV_AbdominalArteriesLateral.OVARIAN_ARTERY_T_46980.getValue(); break;
		case TESTICULAR_ARTERY: this.strCodeValue =EnumCV_AbdominalArteriesLateral.TESTICULAR_ARTERY_T_46970.getValue(); break;
		case UMBILICAL_ARTERY: this.strCodeValue =EnumCV_AbdominalArteriesLateral.UMBILICAL_ARTERY_T_F1810.getValue(); break;
		case UTERINE_ARTERY: this.strCodeValue =EnumCV_AbdominalArteriesLateral.UTERINE_ARTERY_T_46820.getValue(); break;
		}
	}

	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumAbdominalArteriesLateral Object of EnumCM_AbdominalArteriesLateral represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_AbdominalArteriesLateral enumAbdominalArteriesLateral)
	{
		switch(enumAbdominalArteriesLateral)
		{
		case ACCESSORY_RENAL_ARTERY : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.ACCESSORY_RENAL_ARTERY.getSNOMEDCTID(); break;
		case GASTRIC_ARTERY : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.GASTRIC_ARTERY.getSNOMEDCTID(); break;
		case OVARIAN_ARTERY : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.OVARIAN_ARTERY.getSNOMEDCTID(); break;
		case TESTICULAR_ARTERY : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.TESTICULAR_ARTERY.getSNOMEDCTID(); break;
		case UMBILICAL_ARTERY : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.UMBILICAL_ARTERY.getSNOMEDCTID(); break;
		case UTERINE_ARTERY : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.UTERINE_ARTERY.getSNOMEDCTID(); break;
		}
	}

	/**
	 * Sets the value for AbdominalArteriesLateral
	 * @param enumAbdominalArteriesLateral Object of EnumCM_AbdominalArteriesLateral.
	 */
	public void setAbdominalArteriesLateral(EnumCM_AbdominalArteriesLateral enumAbdominalArteriesLateral)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumAbdominalArteriesLateral.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
		
		/**
		 * set code Value
		 */
		setCodeValue(enumAbdominalArteriesLateral);

		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumAbdominalArteriesLateral);
	}
}
